/**
 * jsetl � A Java library that combines the object-oriented
 * programming paradigm with valuable concepts of CLP languages
 *
 * Copyright (C) 2000-2012 jsetl Team.
 *
 * jsetl is distributed under the terms of the GNU Lesser General
 * Public License.
 */

/**
 * AllTests.java
 * @version 2.3
 *
 */
 
package jsetl.test;

import junit.framework.Test;
import junit.framework.TestSuite;

public class AllTests {

    public static Test suite() {
        TestSuite suite = new TestSuite();
        
        //$JUnit-BEGIN$
        suite.addTestSuite(ANDTest.class);
        suite.addTestSuite(BoolLVarTest.class);
        suite.addTestSuite(ConstraintArithmTest.class);
        suite.addTestSuite(ConstraintClassTest.class);
        suite.addTestSuite(ConstraintEqTest.class);
        suite.addTestSuite(ConstraintNeqInNinTest.class);
        suite.addTestSuite(ConstraintSetTest.class);
        suite.addTestSuite(HeuristicsTest.class);
        suite.addTestSuite(IntervalTest.class);
        suite.addTestSuite(IntLSetTest.class);
        suite.addTestSuite(IntLVarTest.class);
        suite.addTestSuite(LListTest.class);
        suite.addTestSuite(LPairTest.class);
        suite.addTestSuite(LMapTest.class);
        suite.addTestSuite(LSetTest.class);
        suite.addTestSuite(LRelTest.class);
        suite.addTestSuite(LVarContainingLListTest.class);
        suite.addTestSuite(LVarTest.class);
        suite.addTestSuite(MultiIntervalTest.class);
        suite.addTestSuite(ORTest.class);
        suite.addTestSuite(PartiallySpecifiedFSTest.class);
        suite.addTestSuite(SetContainsTest.class);
        suite.addTestSuite(SetIntervalTest.class);              
        suite.addTestSuite(SetLVarTest.class);
        suite.addTestSuite(SolverTest.class);
        suite.addTestSuite(TestNeqRemoval.class);
        suite.addTestSuite(RisTest.class);
        suite.addTestSuite(RisIntegrationTest.class);
        suite.addTestSuite(LCollectionIteratorTest.class);
//        suite.addTestSuite(CPexpandTest.class);
        suite.addTestSuite(ConstraintStringComparatorTest.class);
        //suite.addTestSuite(ParallelSolverTest.class);
        //$JUnit-END$
        return suite;
    }

}
