
//[Ghezzi] Per quanto riguarda la questione del codice inObjectSet(), 
//il codice che ho messo � necessario altrimeti test come il 
//seguente lanciano eccezioni che non dovrebbero:

package jsetl.test.CP;

import jsetl.*;
import jsetl.exception.Failure;

/*
 *             Prova constraint in su CP
 */

class Constraint_in_CP2 {
    public static void main (String[] args) throws Failure {
    	Solver solver = new Solver();
    	
        LSet a = LSet.empty().ins(2).ins(1);       
        LSet b = LSet.empty().ins(3);       
        CP cp = new CP("cp",a,b);   // {1,2} x {3}
        cp.output();
        cp.expand().output();       // {[1,3],[2,3]}
        
        LSet S = cp.ins(new LPair(1,4)).setName("S");   // {[1,4]|{1,2} x {3}}
        S.output();

        LPair y = new LPair(1,4).setName("y");   // [1,4]
		y.output();		
		solver.solve(y.in(S));  // [1,4] in {[1,4]|{1,2} x {3}}

		LPair x = new LPair(1,3).setName("x");   // [1,3]
		x.output();		
		if (solver.check(x.in(S)))  // [1,3] in {[1,4]|{1,2} x {3}}
			System.out.println(x + " appartiene a " + S);
		else
			System.out.println(x + " non appartiene a " + S);
		
	    solver.clearStore();
	    LSet Sespanso = new LSet("S_espanso");
	    solver.solve(Sespanso.union(S, S.getTail()));
	    Sespanso.output();
    }
}

/* Prova esecuzione:
cp = {1,2} x {3}
cp = {[1,3],[2,3]}
S = {[1,4]|{1,2} x {3}}
y = [1,4]
x = [1,3]
[1,3] appartiene a {[1,4]|{1,2} x {3}}
S_espanso = {[1,4]|{1,2} x {3}}
*/
