
package jsetl.test.CP;

import jsetl.*;

/*
 *      Prova constraint subset su CP
 */

class Constraint_subset_CP {
    private static Solver solver = new Solver();
    public static void main (String[] args) {    
        LSet r = LSet.empty().ins(3).ins(1);     
        CP c = new CP("c",r,r);      // {1,3} x {1,3}
        c.output();
        
        LSet t = LSet.empty().ins(1);
        CP d = new CP("d",t,t);      // {1} x {1}
        d.output();
        
        if (solver.check(d.subset(c)))   // {1} x {1} subset {1,3} x {1,3}
        	System.out.println("true"); 
        else
        	System.out.println("false");    
        
        LSet e = LSet.empty().ins(new LPair(1,1));    //{[1,1]}
        if (solver.check(e.subset(c)))   // {[1,1]} subset {1,3} x {1,3}
        	System.out.println("true"); 
        else
        	System.out.println("false");    

        LSet f = e.ins(new LPair(3,4)); 
        if (solver.check(f.subset(c)))   // {[3,4],[1,1]} subset {1,3} x {1,3}
        	System.out.println("true"); 
        else
        	System.out.println("false");  
 
        LSet g = e.ins(new LPair(3,3)); 
        g.setName("g").output();
        c.expand().setName("c").output();
        if (solver.check(g.subset(c)))   // {[3,3],[1,1]} subset {1,3} x {1,3}
        	System.out.println("true"); 
        else
        	System.out.println("false");  
 
        LSet h = e.ins(new LPair(3,3)).ins(new LPair(3,1)); 
        h.setName("h").output();
        c.expand().setName("c").output();
        if (solver.check(h.subset(c)))   // {[3,1],[3,3],[1,1]} subset {1,3} x {1,3}
        	System.out.println("true"); 
        else
        	System.out.println("false");  
    }
}

/* Prova esecuzione:
c = {1,3} x {1,3}
d = {1} x {1}
true
true
false
true
*/