package jsetl.test.CP;

import static org.junit.Assert.assertTrue;

import jsetl.exception.Failure;
import org.junit.*;
import jsetl.*;

public class ProvaEq {
	
	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	//CP LEGATO A LSET VUOTO
	@Test
	public void eq1_1() throws Throwable {
		Solver solver = new Solver();
		LSet A = new LSet();
		LSet B = new LSet();
		CP c = new CP(A,B);
		solver.solve(c.eq(LSet.empty()));
		assertTrue( A.equals(LSet.empty()) );
	}
	
	//CP LEGATO A LSET VUOTO
	@Test
	public void eq1_2() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1);
		LSet B = new LSet();
		CP c = new CP(A,B);
		solver.solve(c.eq(LSet.empty()));
		assertTrue( B.equals(LSet.empty()) );
	}
		
	//CP LEGATO A UN ALTRO CP
	@Test
	public void eq2() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1);
		LSet B = LSet.empty().ins(2);
		LSet C = new LSet();
		LSet D = new LSet();
		CP c1 = new CP(A,B);
		CP c2 = new CP(C,D);
 		solver.solve(c1.eq(c2));
 		assertTrue(c1.equals(c2));
	}
		
	//CP CON PRIMO INSIEME VUOTO
	@Test
	public void eq3() throws Throwable {
		Solver solver = new Solver();
		LSet X = LSet.empty();
		LSet Y = LSet.empty().ins(1);
		LSet Z = new LSet();
		CP c = new CP(X,Y);
 		solver.solve(c.eq(Z));
 		assertTrue(Z.equals(LSet.empty()));
	}
		
	//CP CON SECONDO INSIEME VUOTO
	@Test
	public void eq4() throws Throwable {
		Solver solver = new Solver();
		LSet X = LSet.empty().ins(1);
		LSet Y = LSet.empty();
		LSet Z = new LSet();
		CP c = new CP(X,Y);
 		solver.solve(c.eq(Z));
		assertTrue(Z.equals(LSet.empty()));
	}
	
	//DISEQUIVALENZA TRA CP E LSET CORRETTA
	@Test
	public void neq1_T() throws Throwable {
		Solver solver = new Solver();
		LSet Z = LSet.empty().ins(new LPair(2,'a'));
		LSet X = LSet.empty().ins(2);
		LSet Y = LSet.empty().ins(3);
		CP c = new CP(X,Y);
		assertTrue( solver.check(c.neq(Z)));
	}
	
	//DISEQUIVALENZA TRA CP E LSET FALSA
	@Test(expected = Failure.class)
	public void neq1_F() throws Throwable {
		Solver solver = new Solver();
		LSet Z = LSet.empty().ins(new LPair(2,'a'));
		LSet X = LSet.empty().ins(2);
		LSet Y = LSet.empty().ins('a');
		CP c = new CP(X,Y);
		solver.solve(c.neq(Z));
	}
}




























