package jsetl.test.CP;

import static org.junit.Assert.assertTrue;

import jsetl.exception.Failure;
import org.junit.*;
import jsetl.*;

public class ProvaIn {
	
	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}
	
	//IN PER UN LVAR CONTENENTE LPAIR (TRUE)
	@Test
	public void in1_T() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1).ins(2);
		LSet B = LSet.empty().ins(3).ins(4);
		CP cp = new CP(A,B);
		LPair z = new LPair(1,3);
		solver.solve(z.in(cp));
	}
	
	//IN PER UN LVAR CONTENENTE LPAIR (FALSE)
	@Test(expected = Failure.class)
	public void in1_F() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1).ins(2);
		LSet B = LSet.empty().ins(3).ins(4);
		CP cp = new CP(A,B);
		LPair z = new LPair(1,6);
		solver.solve(z.in(cp));
	}
	
	//NIN PER UN LVAR (TRUE)
	@Test
	public void nin1_T() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1).ins(2);
		LSet B = LSet.empty().ins(3).ins(4);
		CP cp = new CP(A,B);
		LVar z = new LVar(new LPair(1,7));
		solver.solve(z.nin(cp));
	}
	
	//NIN PER UN LVAR (FALSE)
	@Test(expected = Failure.class)
	public void nin1_F() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1).ins(2);
		LSet B = LSet.empty().ins(3).ins(4);
		CP cp = new CP(A,B);
		LVar z = new LVar(new LPair(1,4));
		solver.solve(z.nin(cp));
	}
}