package jsetl.test.CP;

import static org.junit.Assert.assertTrue;

import jsetl.exception.Failure;
import org.junit.*;
import jsetl.*;

public class ProvaVincoliDefiniti2 {
	
	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}
	
	//nun, ndisj, nsubset, ninters, ndiff
	
	//NUNION CASE 0
	@Test
	public void nunionTest1() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1);
		LSet B = LSet.empty().ins(2);
		LSet C = LSet.empty().ins(3);
		solver.solve(A.nunion(B, C));
	}
	
	//NUNION CASE 1
	@Test
	public void nunionTest2() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(2);
		LSet B = LSet.empty().ins(3);
		LSet C = LSet.empty().ins(3);
		solver.solve(A.nunion(B, C));
	}
	
	//NUNION CASE 2
	@Test
	public void nunionTest3() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(3);
		LSet B = LSet.empty().ins(2);
		LSet C = LSet.empty().ins(3);
		solver.solve(A.nunion(B, C));
	}
	
	//NUNION FALLIMENTARE
	@Test(expected = Failure.class)
	public void nunionTest4() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1);
		LSet B = LSet.empty().ins(2);
		LSet C = LSet.empty().ins(1).ins(2);
		solver.solve(A.nunion(B, C));
	}
	
	//NUNION CON CP
	@Test
	public void nunionTest5() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1);			//	A = {1}
		LSet B = LSet.empty().ins(2);			//	B = {2}
		CP cp = new CP(A,B);					//  cp = { {1} x {2} }
		solver.solve(A.nunion(B, cp));
	}
	
	//NDISJ CON LSET
	@Test
	public void ndisjTest1() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1).ins(2);
		LSet B = LSet.empty().ins(2).ins(3);
		solver.solve(A.ndisj(B));
	}
	
	//NDISJ CON LSET FALLIMENTARE
	@Test(expected = Failure.class)
	public void ndisjTest2() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1).ins(2);
		LSet B = LSet.empty().ins(3).ins(4);
		solver.solve(A.ndisj(B));
	}
	
	//NDISJ CON CP
	@Test
	public void ndisjTest3() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1).ins(2);				// {2,1}
		LSet B = LSet.empty().ins(2).ins(3);				// {3,2}
		LSet C = LSet.empty().ins(new LPair(2,2));   		// {[2,2]}
		CP cp = new CP(A,B);								// {2,1} x {3,2}
		solver.solve(cp.ndisj(C));	
	}
	
	//NDISJ CON CP (FALLIMENTARE)
	@Test(expected = Failure.class)
	public void ndisjTest4() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1).ins(2);		// {2,1}
		LSet B = LSet.empty().ins(2).ins(3);		// {3,2}
		LSet C = LSet.empty().ins(3);   			// {3}
		CP cp = new CP(A,B);						// {2,1} x {3,2}
		solver.solve(cp.ndisj(C));			
	}
	
	//NSUBSET CON LSET
	@Test
	public void nsubsetTest1() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(3);
		LSet B = LSet.empty().ins(1).ins(2);
		solver.solve(A.nsubset(B));
	}
	
	//NSUBSET CON LSET (FALLIMENTARE)
	@Test(expected = Failure.class)
	public void nsubsetTest2() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1);
		LSet B = LSet.empty().ins(1).ins(2);
		solver.solve(A.nsubset(B));
	}
	
	//NSUBSET CON CP
	@Test
	public void nsubsetTest3() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1);
		LSet B = LSet.empty().ins(2);
		LSet C = LSet.empty().ins(3);		// {3}
		CP cp = new CP(A,B);				// {1} x {2}
		solver.solve(cp.nsubset(C));
	}
	
	//NSUBSET CON CP (FALLIMENTARE)
	@Test(expected = Failure.class)
	public void nsubsetTest4() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1).ins(2);
		LSet B = LSet.empty().ins(2).ins(3);
		LSet C = LSet.empty().ins(new LPair(2,2));		// {[2,2]}
		CP cp = new CP(A,B);							// {2,1} x {3,2}
		solver.solve(C.nsubset(cp));
	}
	
	//INTERS CON LSET
	@Test
	public void nintersTest1() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1).ins(2);
		LSet B = LSet.empty().ins(2).ins(3);
		LSet C = LSet.empty().ins(5);
		solver.solve(A.ninters(B,C));
	}


	@Test(expected = Failure.class)
	public void nintersTest2() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1).ins(2);
		LSet B = LSet.empty().ins(2).ins(3);
		LSet C = LSet.empty().ins(2);
		solver.solve(A.ninters(B,C));
	}

	@Test(expected = Failure.class)
	public void nintersTest3() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(2);
		LSet B = LSet.empty().ins(2).ins(3);
		LSet C = LSet.empty().ins(2);
		solver.solve(A.ninters(B,C));
	}

	
	//NDIFF CON LSET
	@Test
	public void ndiffTest1() throws Throwable {
		Solver solver = new Solver();
		LSet A = LSet.empty().ins(1).ins(2);	// {2,1}
		LSet B = LSet.empty().ins(2).ins(3);	// {3,2}
		LSet C = LSet.empty().ins(2);			// {2}
		solver.solve(A.ndiff(B, C));
	}

    @Test(expected = Failure.class)
    public void ndiffTest2() throws Throwable {
        Solver solver = new Solver();
        LSet A = LSet.empty().ins(1).ins(2);	// {2,1}
        LSet B = LSet.empty().ins(2).ins(3);	// {3,2}
        LSet C = LSet.empty().ins(1);			// {2}
        solver.solve(A.ndiff(B, C));
    }
}
