package jsetl.test;

//import static org.junit.jupiter.api.Assertions.*;

//import org.junit.jupiter.api.Test;

import junit.framework.TestCase;
import jsetl.*;
import org.junit.Test;

public class TestNeqRemoval extends TestCase {

//	@Test
	public void test01() {
		LSet A1 = new LSet();
		LSet A2 = new LSet();
		LSet B = new LSet();
		LSet C = new LSet();
		Solver solver = new Solver();
		solver.add(B.union(C, A1));
		solver.add(B.union(C, A2));
		solver.add(A1.neq(A2));
		assertEquals(false, solver.check());

	}
	
//	@Test
	public void test02() {
		LSet A1 = new LSet("A");
		LSet B1 = new LSet("B1");
		LSet B2 = new LSet("B2");

		LSet C = new LSet("C");
		Solver solver = new Solver();
		solver.add(A1.union(B1, C));
		solver.add(A1.union(B2, C));
		solver.add(C.disj(B1));
		solver.add(C.disj(B2));
		solver.add(B1.neq(B2));
		
		solver.add(C.eq(LSet.empty()));

		assertEquals(false, solver.check());

	}
	
//	@Test
	public void test02bis() { //without disjoint
		LSet A1 = new LSet("A");
		LSet B1 = new LSet("B1");
		LSet B2 = new LSet("B2");

		LSet C = new LSet("C");
		Solver solver = new Solver();
		solver.add(B1.union(C, A1));
		solver.add(B2.union(C,A1));

		solver.add(B1.neq(B2));
		assertEquals(true, solver.check());

	}
	
//	@Test
	public void test02tris() {
		LSet A1 = new LSet("A");
		LSet B1 = new LSet("B1");
		LSet B2 = new LSet("B2");

		LSet C = new LSet("C");
		Solver solver = new Solver();
		solver.add(B1.union(C, A1));
		solver.add(B2.union(C, A1));
		solver.add(C.disj(B1));
		solver.add(C.disj(B2));
		solver.add(B1.neq(B2));
		
		solver.add(C.neq(LSet.empty()));
		assertEquals(false, solver.check());

	}
	
//	@Test
	public void test03() { //senza disjoint
		LSet A1 = new LSet();
		LSet A2 = new LSet();
		LSet B1 = new LSet();
		LSet B2 = new LSet();
		
		LVar a = new LVar();

		LSet C = new LSet();
		Solver solver = new Solver();
		solver.add(A1.union(B1, C));
		solver.add(A1.union(B2, C));
		
		assertEquals(true, solver.check());

	}
	
//	@Test
	public void test04() {
		LSet A1 = new LSet();
		LSet B1 = new LSet();

		LSet C = new LSet();
		Solver solver = new Solver();
		solver.add(A1.union(B1, C));
		solver.add(C.disj(B1));
		solver.add(C.disj(A1));
		solver.add(C.neq(LSet.empty()));
		assertEquals(false, solver.check());

	}
	
//	@Test
	public void test04bis() {
		LSet A1 = new LSet();
		LSet B1 = new LSet();

		LSet C = new LSet();
		Solver solver = new Solver();
		solver.add(A1.union(B1, C));
		solver.add(C.disj(B1));
		solver.add(C.disj(A1));
		assertEquals(true, solver.check());
	}
	
//		@Test
	public void test05() {
		IntLSet A1 = new IntLSet();
		IntLSet B1 = new IntLSet();

		IntLSet C = new IntLSet();
		Solver solver = new Solver();
		solver.add(A1.union(B1, C));
		solver.add(C.disj(B1));
		solver.add(C.disj(A1));
		solver.add(C.neq(LSet.empty()));
		assertEquals(false, solver.check());

	}
	
//	@Test
	public void test05bis() {
		IntLSet A1 = new IntLSet();
		IntLSet B1 = new IntLSet();

		IntLSet C = new IntLSet();
		Solver solver = new Solver();
		solver.add(A1.union(B1, C));
		solver.add(C.disj(B1));
		solver.add(C.disj(A1));
		assertEquals(true, solver.check());

	}

    //		@Test
    public void testOR01() {
        IntLSet A1 = new IntLSet();
        IntLSet B1 = new IntLSet();

        IntLSet C = new IntLSet();
        Solver solver = new Solver();
        solver.add(A1.union(B1, C).or(A1.union(B1, C)));
        solver.add(C.disj(B1).or(C.disj(B1)));
        solver.add(C.disj(A1).or(C.disj(A1)));
        solver.add(C.neq(LSet.empty()).or(C.neq(LSet.empty())));
        assertEquals(false, solver.check());

    }

    //	@Test
    public void testOR02() {
        IntLSet A1 = new IntLSet();
        IntLSet B1 = new IntLSet();

        IntLSet C = new IntLSet();
        Solver solver = new Solver();
        solver.add(A1.union(B1, C).or(A1.union(B1, C)));
        solver.add(C.disj(B1).or(C.disj(B1)));
        solver.add(C.disj(A1).or(C.disj(A1)));
        assertEquals(true, solver.check());

    }

	@Test
	public void testNeqRemovalInvTrue01(){
		LRel lRel = new LRel("lrel");
		Solver solver = new Solver();
		LRel inv = new LRel("inv");
		LRel invinv = new LRel();
		solver.add(inv.inv(lRel));
		solver.add(inv.inv(invinv));
		assertTrue(solver.check());
	}

	@Test
	public void testNeqRemovalInvTrue02(){
		LRel lRel = new LRel("lrel");
		Solver solver = new Solver();
		LRel inv = new LRel("inv");
		solver.add(inv.inv(lRel));
		solver.add(inv.inv(inv));
		assertTrue(solver.check());
	}

	@Test
	public void testNeqRemovalInvFalse01(){
		LRel lRel = new LRel("lrel");
		Solver solver = new Solver();
		LRel inv = new LRel("inv");
		LRel invinv = new LRel();
		solver.add(inv.inv(lRel));
		solver.add(inv.inv(invinv));
		solver.add(invinv.neq(lRel));
		assertFalse(solver.check());
	}

	@Test
	public void testNeqRemovalBRDomFalse01() {
		LSet a = new LSet(), b = new LSet();
		LSet d = new LSet();
		LRel r = new LRel();
		Solver solver = new Solver();
		solver.add(a.union(d, b));
		solver.add(d.disj(b));
		solver.add(r.dom(d));
		solver.add(r.neq(LRel.empty()));
		assertFalse(solver.check());
	}

	@Test
	public void testNeqRemovalBRDomTrue01() {
		LSet a = new LSet(), b = new LSet();
		LSet d = new LSet();
		LRel r = new LRel();
		Solver solver = new Solver();
		solver.add(a.union(d, b));
		solver.add(d.disj(b));
		solver.add(r.dom(d));
		assertTrue(solver.check());
	}

	@Test
	public void testNeqRemovalPFDomFalse01() {
		LSet a = new LSet(), b = new LSet();
		LSet d = new LSet();
		LMap r = new LMap();
		Solver solver = new Solver();
		solver.add(a.union(d, b));
		solver.add(d.disj(b));
		solver.add(r.dom(d));
		solver.add(r.neq(LRel.empty()));
		assertFalse(solver.check());
	}

	@Test
	public void testNeqRemovalPFDomTrue01() {
		LSet a = new LSet(), b = new LSet();
		LSet d = new LSet();
		LMap r = new LMap();
		Solver solver = new Solver();
		solver.add(a.union(d, b));
		solver.add(d.disj(b));
		solver.add(r.dom(d));
		assertTrue(solver.check());
	}

	@Test
	public void testNeqRemovalBRRanFalse01() {
		LSet a = new LSet(), b = new LSet();
		LSet d = new LSet();
		LRel r = new LRel();
		Solver solver = new Solver();
		solver.add(a.union(d, b));
		solver.add(d.disj(b));
		solver.add(r.ran(d));
		solver.add(r.neq(LRel.empty()));
		assertFalse(solver.check());
	}

	@Test
	public void testNeqRemovalBRRanTrue01() {
		LSet a = new LSet(), b = new LSet();
		LSet d = new LSet();
		LRel r = new LRel();
		Solver solver = new Solver();
		solver.add(a.union(d, b));
		solver.add(d.disj(b));
		solver.add(r.ran(d));
		assertTrue(solver.check());
	}

	@Test
	public void testNeqRemovalPFRanFalse01() {
		LSet a = new LSet(), b = new LSet();
		LSet d = new LSet();
		LMap r = new LMap();
		Solver solver = new Solver();
		solver.add(a.union(d, b));
		solver.add(d.disj(b));
		solver.add(r.ran(d));
		solver.add(r.neq(LRel.empty()));
		assertFalse(solver.check());
	}

	@Test
	public void testNeqRemovalPFRanTrue01() {
		LSet a = new LSet(), b = new LSet();
		LSet d = new LSet();
		LMap r = new LMap();
		Solver solver = new Solver();
		solver.add(a.union(d, b));
		solver.add(d.disj(b));
		solver.add(r.ran(d));
		assertTrue(solver.check());
	}

	@Test
	public void testNeqRemovalBRCompFalse01() {
		LRel a = new LRel();
		LRel b = new LRel();
		LRel c = new LRel();
		LRel d = new LRel();

		Solver solver = new Solver();
		solver.add(a.comp(b,c));
		solver.add(a.union(b, d));
		solver.add(a.disj(d));
		solver.add(c.neq(LRel.empty()));
		assertFalse(solver.check());
	}

	@Test
	public void testNeqRemovalBRCompTrue01() {
		LRel a = new LRel();
		LRel b = new LRel();
		LRel c = new LRel();
		LRel d = new LRel();

		Solver solver = new Solver();
		solver.add(a.comp(b,c));
		solver.add(a.union(b, d));
		solver.add(a.disj(d));
		assertTrue(solver.check());
	}

	@Test
	public void testNeqRemovalPFCompFalse01() {
		LMap a = new LMap();
		LMap b = new LMap();
		LMap c = new LMap();
		LMap d = new LMap();

		Solver solver = new Solver();
		solver.add(a.comp(b,c));
		solver.add(a.union(b, d));
		solver.add(a.disj(d));
		solver.add(c.neq(LRel.empty()));
		assertFalse(solver.check());
	}

	@Test
	public void testNeqRemovalPFCompTrue01() {
		LMap a = new LMap();
		LMap b = new LMap();
		LMap c = new LMap();
		LMap d = new LMap();

		Solver solver = new Solver();
		solver.add(a.comp(b,c));
		solver.add(a.union(b, d));
		solver.add(a.disj(d));
		assertTrue(solver.check());
	}

	@Test
	public void testNeqRemovalBRIdFalse01() {
		LSet a = new LSet(), b = new LSet();
		LSet d = new LSet();
		LRel r = new LRel();
		Solver solver = new Solver();
		solver.add(a.union(d, b));
		solver.add(d.disj(b));
		solver.add(r.id(d));
		solver.add(r.neq(LRel.empty()));
		assertFalse(solver.check());
	}

	@Test
	public void testNeqRemovalBRIdTrue01() {
		LSet a = new LSet(), b = new LSet();
		LSet d = new LSet();
		LRel r = new LRel();
		Solver solver = new Solver();
		solver.add(a.union(d, b));
		solver.add(d.disj(b));
		solver.add(r.id(d));
		assertTrue(solver.check());
	}

	@Test
	public void testNeqRemovalPFIdFalse01() {
		LSet a = new LSet(), b = new LSet();
		LSet d = new LSet();
		LMap r = new LMap();
		Solver solver = new Solver();
		solver.add(a.union(d, b));
		solver.add(d.disj(b));
		solver.add(r.id(d));
		solver.add(r.neq(LRel.empty()));
		assertFalse(solver.check());
	}

	@Test
	public void testNeqRemovalPFIdTrue01() {
		LSet a = new LSet(), b = new LSet();
		LSet d = new LSet();
		LMap r = new LMap();
		Solver solver = new Solver();
		solver.add(a.union(d, b));
		solver.add(d.disj(b));
		solver.add(r.id(d));
		assertTrue(solver.check());
	}




}
